//////////////////////////////
// Soldier Code
//////////////////////////////

function init_mouse();
function clear_circle(&center,rad,pixel);
function draw_box_line(&vec1,&vec2,pixel);

action fog_war_spr {
	my.passable = on;
	my.overlay = on;
	my.oriented = on;
	my.tilt = 90;
	fog_war = my;
	fog_war_map = bmap_for_entity(my,0);
	}	
	
action target_dot {
	my.oriented = on;
	my.passable = on;
	my.bright = on;
	my.near = on;
	wait(1);
	while(my.energy < 270) {
		my.scale_x = 1 + sin(my.energy);
		my.scale_y = 1 + sin(my.energy);
		vec_scale(my.scale_x,0.75);
		
		my.energy += 25 * time;
		wait(1);
		}
	ent_Remove(me);
	
	}	

action select_ring {
	my.invisible = on;
	my.passable = on;
	my.oriented = on;
	my.bright = on;
	my.near = on;
	wait(1);
	while(my != null){
		you = null;
		you = ptr_for_handle(my.parent_handle);
		if(you != null) {
			vec_set(my.x,you.x);
			my.z = you.z - 20 * you.scale_z;
			my.tilt = you.tilt + 90;
			my.roll = you.roll;
			my.pan += 5 * time;
			if(you.selected == on) {my.invisible = off;}
			if(you.selected == off) {my.invisible = on;}
			}
		if(you == null) {ent_remove(me);}	
		wait(1);
		}		
	}
	
action hbar_line {
	vec_scale(my.scale_x,0.5);
	my.invisible = on;
	my.passable = on;
	my.oriented = on;
	my.near = on;
	my.skill1 = my.max_y - my.min_y;	//entity width
	wait(1);
	while(my){
		you = null;
		you = ptr_for_handle(my.parent_handle);
		if(you != null) {
			vec_set(my.x,vector(10,0,0));
			vec_rotate(my.x,you.pan);
			vec_add(my.x,you.x);
			vec_set(my.pan,you.pan);
			if(you.invisible == on) {my.invisible = on;}
			if(you.invisible == off) {my.invisible = off;}
			}
		if(you == null) {ent_remove(me);}
		wait(1);
		}		
	}
	
action hbar_redline {
	vec_scale(my.scale_x,0.5);
	my.invisible = on;
	my.passable = on;
	my.oriented = on;
	my.near = on;
	my.skill1 = my.max_y - my.min_y;	//entity width
	wait(1);
	while(my){
		you = null;
		you = ptr_for_handle(my.parent_handle);
		if(you != null) {
			vec_set(my.x,vector(5,0,0));
			vec_rotate(my.x,you.pan);
			vec_add(my.x,you.x);
			vec_set(my.pan,you.pan);
			if(you.invisible == on) {my.invisible = on;}
			if(you.invisible == off) {my.invisible = off;}
			}
		if(you == null) {ent_remove(me);}
		wait(1);
		}		
	}		
	
action hbar_back {
	vec_scale(my.scale_x,0.5);
	my.invisible = on;
	my.passable = on;
	my.oriented = on;
//	my.near = on;
	you = ent_create(hbar_spr,my.x,hbar_line);
	you.parent_handle = handle(me);
	you = ent_create(hbarred_spr,my.x,hbar_redline);
	you.parent_handle = handle(me);
	wait(1);
	while(my){
		you = null;
		you = ptr_for_handle(my.parent_handle);
		if(you != null) {
			vec_set(my.x,you.x);
			my.z = you.z + 40;						
			vec_diff(temp,camera.x,my.x);
			vec_to_angle(my.pan,temp);
			my.pan = -90;
			if(you.selected == on) {my.invisible = off;}
			if(you.selected == off) {my.invisible = on;}
			}
		if(you == null) {ent_remove(me);}
		wait(1);
		}		
	}
	

function soldier_Scan_event() {
	if(event_Type == event_Detect && you != null) {
		vec_diff(temp,you.x,my.x);
		vec_to_Angle(temp_Ang,temp);
		temp_var = sign(ang(temp_Ang.pan - my.pan));
		if(!temp_var) {temp_var = 1;}
		if(abs(temp_var) <= 90) {
			my.pan += 20 * temp_var * time;
			if(vec_dist(my.x,my.target_x) >= vec_dist(You.x,my.target_X) && vec_Dist(my.x,my.target_x) <= 100) {
				my.mode = mode_stand;
				my.anim_index = 0;
				}
			}
		}
	}	

//uses speed, agility, team, sight_dist
action soldier {
	my.mode = mode_stand;
	my.speed = 6;
	my.agility = 40;
	my.team = 1;
	my.sight_dist = 200;
	my.anim_index = random(100); //randomize animation a little
	you = ent_create(select_ring_spr,my.x,select_ring);
	you.parent_handle = handle(me);
	you = ent_create(hbar_back_spr,my.x,hbar_back);
	you.parent_handle = handle(me);
	my.enable_scan = on;
	my.enable_Detect = on;
	my.event = soldier_scan_Event;
	while(1) {
		if(my.mode == mode_stand) {	//stand
			my.anim_index += time;
			my.fog_scan -= 0.1 * time;
			ent_Animate(my,"stand",my.anim_index,anm_cycle);
			}
		
		if(my.mode == mode_move) {		//move to location stored in my.target_x
			my.force_x = my.speed * time;
			vec_diff(temp,my.target_x,my.x);
			vec_to_angle(my.ang_pan,temp);
			temp_ang.pan = ang(my.ang_pan - my.pan);
			if(temp_ang.pan > 0) { my.pan += min(my.agility * time,abs(temp_ang.pan));	}
			if(temp_ang.pan < 0) { my.pan -= min(my.agility * time,abs(temp_ang.pan));	}
			my.anim_index += 5 * time;
			ent_animate(my,"run",my.anim_index,anm_cycle);
			my.unit_scan -= time;
			if(my.unit_scan <= 0) {
				my.unit_scan = unit_scan_time;
				vec_set(temp,vector(360,360,100));
				you = null;
				scan_entity(my.x,temp);
			}			
			move_friction = 0;	
			move_mode = ignore_passable + glide;
			ent_move(my.force_x,nullvector);
			
			if(vec_dist(my.target_x,my.x) < 40) {	//close enough to destination -> stop moving
				my.mode = mode_stand;
				my.anim_index = 0;
				}
			}	
				
		if(my.selected == on && dest_set) {   
			vec_Set(my.target_X,dest_pos);
			my.mode = mode_move;
			if(my.mode != mode_move) {my.anim_index = 0;}
			}	
			
		if(left_pressed) {my.selected = off;}	

		if(fog_war_map != null && fog_war != null && my.fog_scan <= 0) {						
			vec_set(clearfog,my.x);
			clearfog.x *= -(1/fog_war.scale_X);	//invert x coord
			clearfog.y *= (1/fog_war.scale_y);			
			vec_add(clearfog,vector(500,500,0));
			clearfog.z = 0;
			temp_format = bmap_lock(fog_war_map,0);
			temp_pixel = pixel_for_vec(vector(0,0,0),0,temp_format);
			clear_circle(clearfog,my.sight_dist,temp_pixel);
			bmap_unlock(fog_war_map);
			my.fog_scan = fog_scan_Time;
			}
		if(my.mode != mode_Stand) {my.fog_scan -= time;}	
		wait(1);
		}	
	
	}
	
function clear_circle(&center,rad,pixel) {		//clear out a circle of fog_war_map
	var p[3];
	var cen[3];
	vec_set(cen,center);
	var bound1[3];
	var bound2[3];
	rad *= 1/fog_war.scale_X;
	vec_set(bound1,vector(cen.x - rad,cen.y - rad,0));
	vec_set(bound2,vector(cen.x + rad,cen.y + rad,0));
	vec_set(p,bound1);
	while(p.y <= bound2.y) {
		p.x = bound1.x;
		while(p.x <= bound2.x) {
			if(vec_dist(p,cen) <= rad) {
				pixel_to_bmap(fog_war_map,p.x,p.y,pixel);
				}			
			p.x += 1;
			}
		p.y += 1;
		}

	}	